summaryrefslogtreecommitdiff
path: root/tests/mkdir/parents
diff options
context:
space:
mode:
Diffstat (limited to 'tests/mkdir/parents')
-rwxr-xr-xtests/mkdir/parents76
1 files changed, 76 insertions, 0 deletions
diff --git a/tests/mkdir/parents b/tests/mkdir/parents
new file mode 100755
index 0000000..f0ead6e
--- /dev/null
+++ b/tests/mkdir/parents
@@ -0,0 +1,76 @@
+#!/bin/sh
+# make sure mkdir's -p options works properly
+
+# Copyright (C) 2000, 2004, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ mkdir --version
+fi
+
+pwd=`pwd`
+tmp=parents-$$
+trap 'status=$?; cd "$pwd" && rm -rf $tmp && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+
+# Record absolute path of srcdir.
+cd $srcdir || framework_failure=1
+abs_srcdir=`pwd`
+
+cd "$pwd" || framework_failure=1
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir -m 700 e-dir || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo 'failure in testing framework'
+ (exit 1); exit 1
+fi
+
+. "$abs_srcdir/../setgid-check"
+
+fail=0
+
+# Make sure `mkdir -p existing-dir' succeeds
+# and that `mkdir existing-dir' fails.
+mkdir -p e-dir || fail=1
+mkdir e-dir > /dev/null 2>&1 && fail=1
+
+# Create an existing directory.
+umask 077
+mode_str=drwxr-x-wx
+mode_arg=`"$abs_srcdir/../rwx-to-mode" $mode_str`
+mkdir -m $mode_arg a || fail=1
+
+# this `mkdir -p ...' shouldn't change perms of existing dir `a'.
+d_mode_str=drwx-w--wx
+d_mode_arg=`"$abs_srcdir/../rwx-to-mode" $d_mode_str`
+mkdir -p -m $d_mode_arg a/b/c/d
+
+# Make sure the permissions of `a' haven't been changed.
+p=`ls -ld a|sed 's/ .*//'`; case $p in $mode_str);; *) fail=1;; esac
+# `b's and `c's should reflect the umask
+p=`ls -ld a/b|sed 's/ .*//'`; case $p in drwx------);; *) fail=1;; esac
+p=`ls -ld a/b/c|sed 's/ .*//'`; case $p in drwx------);; *) fail=1;; esac
+
+# `d's perms are determined by the -m argument.
+p=`ls -ld a/b/c/d|sed 's/ .*//'`; case $p in $d_mode_str);; *) fail=1;; esac
+
+(exit $fail); exit $fail